标签:leetcode hash table array two sum
Given an array of integers, find two numbers such that they add up to a specific target number.
The function twoSum should return indices of the two numbers such that they add up to the target, where index1 must be less than index2. Please note that your returned answers (both index1 and index2) are not zero-based.
You may assume that each input would have exactly one solution.
Input: numbers={2, 7, 11, 15}, target=9
Output: index1=1, index2=2
使用暴力求解。时间复杂度O(n^2),空间复杂度O(1)。
使用hash表存储访问过的数。时间复杂度O(n),空间复杂度O(n)。(√)
int[] twoSum(int[] nums, int target ){ HashMap<Integer, Integer> hm = new HashMap<Integer, Integer>(); int[] index=new int[2]; for(int i=0;;i++){ if(hm.containsKey(target-nums[i])){ index[0] = hm.get(target-nums[i])+1; index[1] = i+1; break; } else{ hm.put(nums[i],i); } } return index; }
Submit Time | Status | Run Time | Language |
---|---|---|---|
17 minutes ago | Accepted | 380 ms | java |
版权声明:本文为博主原创文章,未经博主允许不得转载。
标签:leetcode hash table array two sum
原文地址:http://blog.csdn.net/hiboy_111/article/details/47691431